/////////////////////////////////////////////////////
//Beispiel für eine Turtle (Kapitel Turtle)
/////////////////////////////////////////////////////
// Zustand der Turtle
float actX; // aktuelle Position
float actY;
float actW; // aktueller Winkel
color actC=color(0);  // Farbe
boolean penIsDown; // Stift is unten (es wird gemalt)

// gloable Variablen: 
// Fenstergroesse
int w=1000;
int h=1000;

///////////////////////////////////////////////////////////

void settings() {
  size(w, h);
}

void setup() {
  //strokeWeight(2);
  colorMode(HSB,100);
  initTurtle();
  move(500);
  turn(90);
  move(500);
  turn(-90);

}

void draw() {
  drawCommands();
  noLoop();
}

///////////////////////////////////////////////////////////

void drawCommands() {
  penDown();
    move(150);
    turn(90);
    move(100);
    turn(90);
    move(150);
    turn(90);
    move(100);
    turn(90);
  penUp();
  //etwas komplizierter:
  /*
  penDown(); 
  for(int i=0; i<200; i++){
    setColor(color(random(255),255,255));
    move(150);
    turn(90);
    move(100);
    turn(90);
    move(150);
    turn(90);
    move(100);
    turn(90);
    move(random(50));
    turn(90);
    move(random(50));
  }
  penUp();
  */
}

///////////////////////////////////////////////////////////
//
// Turtle Kommandos
//
///////////////////////////////////////////////////////////

void initTurtle() {
  actX=0;
  actY=0;
  actW=0;
  setColor(color(0,0,0));
  penUp();
  // Hintergrund weiß im HSB Modell
  background(0,0,255);
}

void move(float len) {
  float dx = cos(radians(actW))*len;
  float dy = sin(radians(actW))*len;
  if (penIsDown) 
     line(actX,height-actY,actX+dx,height-(actY+dy));
  actX+=dx;
  actY+=dy;
}

void turn(float ang) { actW += ang; }
void setColor(color c) { actC = c; stroke(actC); }
void penUp() { penIsDown = false; }
void penDown() { penIsDown = true; }
